## ros-noetic-mbf-abstract-nav 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(mbf_abstract_nav)

find_package(catkin REQUIRED
  COMPONENTS
  actionlib
  actionlib_msgs
  dynamic_reconfigure
  geometry_msgs
  mbf_msgs
  mbf_abstract_core
  mbf_utility
  nav_msgs
  roscpp
  std_msgs
  std_srvs
  tf
  xmlrpcpp
  )

find_package(Boost COMPONENTS thread chrono REQUIRED)

# dynamic reconfigure: we provide the abstract configuration common to all MBF-based navigation
# frameworks in a python module, so it can easily be included in particular navigation flavours
catkin_python_setup()

generate_dynamic_reconfigure_options(
  cfg/MoveBaseFlex.cfg
)

set(MBF_ABSTRACT_SERVER_LIB mbf_abstract_server)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${MBF_ABSTRACT_SERVER_LIB}
  CATKIN_DEPENDS
      actionlib
      actionlib_msgs
      dynamic_reconfigure
      geometry_msgs
      mbf_msgs
      mbf_abstract_core
      mbf_utility
      nav_msgs
      roscpp
      std_msgs
      std_srvs
      tf
      xmlrpcpp
  DEPENDS Boost
)


include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(${MBF_ABSTRACT_SERVER_LIB}
  src/controller_action.cpp
  src/planner_action.cpp
  src/recovery_action.cpp
  src/move_base_action.cpp
  src/abstract_execution_base.cpp
  src/abstract_navigation_server.cpp
  src/abstract_planner_execution.cpp
  src/abstract_controller_execution.cpp
  src/abstract_recovery_execution.cpp
)

add_dependencies(${MBF_ABSTRACT_SERVER_LIB} ${PROJECT_NAME}_gencfg)
add_dependencies(${MBF_ABSTRACT_SERVER_LIB} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${MBF_ABSTRACT_SERVER_LIB}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

install(TARGETS
  ${MBF_ABSTRACT_SERVER_LIB}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  # gtests
  catkin_add_gtest(${MBF_ABSTRACT_SERVER_LIB}_gtest test/abstract_execution_base.cpp)
  target_link_libraries(${MBF_ABSTRACT_SERVER_LIB}_gtest ${MBF_ABSTRACT_SERVER_LIB})
  
  # ros-tests
  add_rostest_gmock(abstract_action_base_test
    test/abstract_action_base.launch
    test/abstract_action_base.cpp)
  target_link_libraries(abstract_action_base_test ${MBF_ABSTRACT_SERVER_LIB})

  add_rostest_gmock(abstract_controller_execution_test
    test/abstract_controller_execution.launch
    test/abstract_controller_execution.cpp)
  target_link_libraries(abstract_controller_execution_test ${MBF_ABSTRACT_SERVER_LIB})

  add_rostest_gmock(abstract_planner_execution_test
    test/abstract_planner_execution.launch
    test/abstract_planner_execution.cpp)
  target_link_libraries(abstract_planner_execution_test ${MBF_ABSTRACT_SERVER_LIB})

  add_rostest_gmock(planner_action_test
    test/planner_action.launch
    test/planner_action.cpp)
  target_link_libraries(planner_action_test ${MBF_ABSTRACT_SERVER_LIB})
endif()

=== debian/changelog ===
ros-noetic-mbf-abstract-nav (0.4.0-1focal) focal; urgency=high

  * Fixes planner execution API compatibility, see #279 and https://github.com/uos/mesh_navigation/issues/18
  * return empty footprint if partly outside of the map, see #272
  * Allow the controller to handle cancel if properly implemented, see #274
  * Do not reset cancel_, as that will invalidate ongoing canceling
  * Run replanning in its own thread, fixes #223, see #267
  * enable max retries logic for controller execution test, see #264
  * fix controller termination, see #263
  * abstract controller execution unit tests, see #261
  * planner action unit tests, see #244
  * Fix number of retries check, see #262
  * transform pose to global frame before calling planner in costmap planner execution, see #256
  * Use ROS rates for sleeping to support simulation time, see #257
  * wait for timeout in abstract eecution base, since cancel call could be missed, see #255
  * add unit test for the abstract execution base, see #249
  * fix race-condition in the test, see #254
  * AbstractPlannerExecution refactoring and unit tests, see #237
  * add documentation, missing includes, joinable check, and fixup and test the abstract_action_base

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 25 Oct 2021 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.3.4-1focal) focal; urgency=high



 -- Sebastian Pütz <spuetz@uos.de>  Tue, 01 Dec 2020 23:00:00 -0000

ros-noetic-mbf-abstract-nav (0.3.3-1focal) focal; urgency=high

  * On move_base action, handle properly RECALLED, REJECTED and LOST status, see #228
  * Fill recovery result field used_plugin, see #229
  * Signal from setState function, see #236
  * Controller fails if robot pose gets older than tf_timeout, see #231
  * Send move_base result when canceled during exe_path and recovery, see #218
  * On controller cancel, wait for the control loop to stop, see #215
  * Ensure MBF does not crash upon receiving an empty path, see #214
  * Make robot_info a reference to keep one single instance, see #204
  * mbf_abstract_nav action event logging from INFO to DEBUG, see #203
  * Fix deallocation on shutdown by discarding all plugins and resetting action server pointers, see #199
  * Move RobotInformation to mbf_utility, as it can be used generaly, see #196

 -- Sebastian Pütz <spuetz@uos.de>  Wed, 04 Nov 2020 23:00:00 -0000

ros-noetic-mbf-abstract-nav (0.3.2-1focal) focal; urgency=high

  * Avoid duplicated warn logging output when we cannot cancel a plugin
  * Remove unused methods and attributes from AbstractNavigationServer, which are already present at other places
  * Reuse execution slots; cleanup only at destruction
  * Enable different goal tolerance values for each action

 -- Sebastian Pütz <spuetz@uos.de>  Sun, 24 May 2020 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.3.1-1focal) focal; urgency=high



 -- Sebastian Pütz <spuetz@uos.de>  Mon, 06 Apr 2020 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.3.0-1focal) focal; urgency=high

  * Clean up patience exceeded method
  * Add last valid cmd time as class variable
  * Add started state and improve output messages
  * Unify license declaration to BSD-3
  * Add parameter force_stop_on_cancel to send a zero-speed command on cancelation (default: true)
  * remove explicit boost-exception dependency, Boost >= 1.69 provides exception by default.
  * Allow the user time-consuming cancel implementations
  * Rename abstract_action.h as abstract_action_base.hpp
  * Remane robot_Information.cpp as robot_information.cpp
  * Unify headers definitions and namespace intentation
  * Add parameter to actively stop once the goal is reached
  * Exit immediately from action done callbacks when action_state is CANCELED

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 30 Mar 2020 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.2.5-1focal) focal; urgency=high

  * Update goal pose on replanning, so the feedback remains consistent
  * Fix: Reset oscillation timer after executing a recovery behavior
  * Remove debug log messages
  * Do not pass boost functions to abstract server to (de)activate costmaps.
    Run instead abstract methods (possibly) overridden in the costmap server,
    all costmap-related handling refactored to a new CostmapWrapper class
  * On controller execution, check that local costmap is current
  * On move_base action, use MoveBaseResult constant to fill outcome in case of oscilation

 -- Sebastian Pütz <spuetz@uos.de>  Thu, 10 Oct 2019 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.2.4-1focal) focal; urgency=high

  * Reduce log verbosity by combining lines and using more DEBUG
  * Concurrency container refactoring
  * Prevent LOST goals when replanning
  * Set as canceled, when goals are preempted by a new plan
  * move setAccepted to abstract action
  * moved listener notification down after setVelocity
  * fix: Correctly fill in the ExePathResult fields
  * Fix controller_patience when controller_max_retries is -1
  * Change current_twist for last_cmd_vel on exe_path/feedback
  * Replace recursive mutexes with normal ones when not needed
  * Give feedback with outcome and message for success and error cases from the plugin.

 -- Sebastian Pütz <spuetz@uos.de>  Sat, 15 Jun 2019 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.2.3-1focal) focal; urgency=high

  * Do not publish path from MBF
  * Single publisher for controller execution objects
  * Ignore max_retries if value is negative and patience if 0
  * Avoid annoying INFO log msg on recovery

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 13 Nov 2018 23:00:00 -0000

ros-noetic-mbf-abstract-nav (0.2.2-1focal) focal; urgency=high

  * Add outcome and message to the action's feedback in ExePath and MoveBase

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 09 Oct 2018 22:00:00 -0000

ros-noetic-mbf-abstract-nav (0.2.1-1focal) focal; urgency=high

  * Fix memory leak
  * Fix uninitialized value for cost
  * Make MBF melodic and indigo compatible
  * Fix GoalHandle references bug in callbacks



=== debian/control ===
Source: ros-noetic-mbf-abstract-nav
Section: misc
Priority: optional
Maintainer: Sebastian Pütz <spuetz@uos.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-actionlib, ros-noetic-actionlib-msgs, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-mbf-abstract-core, ros-noetic-mbf-msgs, ros-noetic-mbf-utility, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-xmlrpcpp
Homepage: http://wiki.ros.org/move_base_flex
Standards-Version: 3.9.2

Package: ros-noetic-mbf-abstract-nav
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-actionlib, ros-noetic-actionlib-msgs, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-mbf-abstract-core, ros-noetic-mbf-msgs, ros-noetic-mbf-utility, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-xmlrpcpp
Description: The mbf_abstract_nav package contains the abstract navigation server implementation of Move Base Flex (MBF).
 The abstract navigation server is not bound to any map representation. It provides the actions for planning, controlling and recovering. MBF loads all defined plugins at the program start. Therefor, it loads all plugins which are defined in the lists *planners*, *controllers* and *recovery_behaviors*. Each list holds a pair of a *name* and a *type*. The *type* defines which kind of plugin to load. The *name* defines under which name the plugin should be callable by the actions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-mbf-abstract-nav//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
